<?php
/* vim: expandtab sw=4 ts=4 sts=4: */
/**
 * runs all defined tests
 *
 * @version $Id: AllTests.php 10291 2007-04-17 10:21:51Z cybot_tm $
 * @package phpMyAdmin-test
 */

/**
 *
 */
if (! defined('PMA_MAIN_METHOD')) {
    define('PMA_MAIN_METHOD', 'AllTests::main');
    chdir('..');
}

/**
 *
 */
require_once 'PHPUnit/Framework.php';
require_once 'PHPUnit/TextUI/TestRunner.php';
//require_once 'PHPUnit/Util/TestDox/ResultPrinter.php.';
require_once './test/FailTest.php';
require_once './test/PMA_get_real_size.php';
require_once './test/PMA_sanitize.php';
require_once './test/PMA_pow.php';
require_once './test/Environment.php';
require_once './test/PMA_escapeJsString.php';
require_once './test/PMA_isValid.php';
require_once './test/PMA_transformation_getOptions.php';
require_once './test/PMA_STR_sub.php';

class AllTests
{
    public static function main()
    {
        $parameters = array();
        //$parameters['testdoxHTMLFile'] = true;
        //$parameters['printer'] = PHPUnit_UtilDox_ResultPrinter::factory('HTML');
        //$parameters['printer'] = PHPUnit_UtilDox_ResultPrinter::factory('Text');
        PHPUnit_TextUIRunner::run(self::suite(), $parameters);
    }

    public static function suite()
    {
        $suite = new PHPUnit_FrameworkSuite('phpMyAdmin');

        //$suite->addTestSuite('FailTest');
        $suite->addTestSuite('Environment');
        $suite->addTestSuite('PMA_get_real_size');
        $suite->addTestSuite('PMA_sanitize');
        $suite->addTestSuite('PMA_pow');
        $suite->addTestSuite('PMA_escapeJsString');
        $suite->addTestSuite('PMA_isValid');
        $suite->addTestSuite('PMA_transformation_getOptions');
        $suite->addTestSuite('PMA_STR_sub');
        return $suite;
    }
}

if (PMA_MAIN_METHOD == 'AllTests::main') {
    echo '<pre>';
    AllTests::main();
    echo '</pre>';
}
?>
